/* Includes */
#include <stdio.h>
#include <stdlib.h>

#define MAX 50

/* Variables globales */

long nInputNodes,
     nHiddenNodes,
     nOutputNodes,
     P,
     nLetters,
     nPatterns,
     L,
     I,
     J,
     nPat_gen;

FILE *fpPattern,
     *fpsnns;

double Input[MAX][MAX],
       target[MAX][MAX];

char pattern[MAX];

void main (int argc, char *argv[])
{
clrscr();

if (argc != 3)  /* No es vlida la linea de comandos */
  {
  printf("\n\nAYUDA: PATSNNS fichero_gramtica fichero_patrones");
  printf("\n       donde:fichero_gramtica -> Es el fichero de entrada con las cadenas\n");
  printf("                                  de la gramtica.");
  printf("\n             fichero_patrones  -> Es el fichero de salida que contentr\n");
  printf("                                  los patrones en SNNS.\n\n");
  exit(1);
  }

/* Abrimos el fichero con las cadenas */
if ((fpPattern = fopen(argv[1], "r")) == NULL)
  {
  printf(" ERROR: No puedo abrir el fichero %s \n",argv[1]);
  exit(1);
  } /* fin if */

/* Creamos el fichero de patrones snns*/
if ((fpsnns = fopen(argv[2], "w")) == NULL)
  {
  printf(" ERROR: No puedo crear el fichero %s \n",argv[2]);
  exit(1);
  } /* fin if */

nPat_gen = 0;
printf("\n**************************** Generar Patrones SNNS **********************");
printf("\n\n N de patrones = ");
scanf("%ld", &nPatterns);
printf(" N de unidades en la capa de entrada = ");
scanf("%ld", &nInputNodes);
printf(" N de unidades en la capa de salida  = ");
scanf("%ld", &nOutputNodes);

for ( P = 0; P < nPatterns; ++P)
  {
  if (fscanf(fpPattern, "%s", pattern) == EOF)
    {
    fcloseall();
    printf(" No hay suficientes patrones !! (slo hay %ld)", P);
    exit(1);
    }
  nLetters = strlen(pattern);	/* N de letras del patrn */
  for (L = 0; L < nLetters - 1; L++)
    {
    /* Unidades de Entrada */
    for (I = 0; I < nInputNodes; I++)
      Input[L][I] = 0;
    switch (pattern[L])
      {
      case 'B': Input[L][0] = 1;
	    break;
      case 'P': Input[L][1] = 1;
	    break;
      case 'S': Input[L][2] = 1;
	    break;
      case 'T': Input[L][3] = 1;
	    break;
      case 'V': Input[L][4] = 1;
	    break;
      case 'X': Input[L][5] = 1;
	    break;
      } /* fin switch */
    for (I = 0; I < nInputNodes; I++)
	 fprintf(fpsnns,"%d ", (int) Input[L][I]);
    fprintf(fpsnns, "\n\n");
    /* Unidades de la salida deseada */
    for (J = 0; J < nOutputNodes; J++)
      target[L][J] = 0;
    switch (pattern[L+1])
    {
    case 'E': target[L][0] = 1;
	  break;
    case 'P': target[L][1] = 1;
	  break;
    case 'S': target[L][2] = 1;
	  break;
    case 'T': target[L][3] = 1;
	  break;
    case 'V': target[L][4] = 1;
	  break;
    case 'X': target[L][5] = 1;
	  break;
    } /* fin switch */
  for (J = 0; J < nOutputNodes; J++)
    fprintf(fpsnns,"%d ", (int) target[L][J]);
  fprintf(fpsnns, "\n\n");
  } /* fin for L */
nPat_gen += nLetters - 1;
printf(" Patrones convertidos: %6ld Patrones generados: %6ld\r", P+1, nPat_gen);
}
printf("\n\n  El fichero %s se ha generado correctamente !!", argv[2]);
fcloseall();
}